<script>
import inputForm from './InputForm.vue';
import selectForm from './SelectForm.vue';
import longTextInput from './LongTextInput.vue';
import multipleTextChoice from './MultipleTextChoice.vue';
import inputDate from './InputDate.vue';
import numberInput from './NumberInput.vue';

export default {
    props: {
        'itemInformations': Object,
        'formItemValue': {}
    },
    emits: ['update:formItemValue', 'update:formItemOfflineStatus'],
    components: {
        inputForm,
        selectForm,
        longTextInput,
        multipleTextChoice,
        inputDate,
        numberInput
    },
    /******************************
     * By default we set each entry of the tab mode to correction. For the inputs that are tracked over time the button allows to toggle between correct and update the value.
     ******************************/
    data() {
        return {
            buttonState: 'corrige'
        }
    },
    methods: {
        toggleButton() {
            if (this.buttonState === 'corrige') {
                this.buttonState = 'maj';
                this.$emit('update:formItemOfflineStatus', 'potentially_added');
            } else {
                this.buttonState = 'corrige';
                this.$emit('update:formItemOfflineStatus', 'potentially_created_or_modified');
            }
        }
    },
    mounted() {
        if (this.buttonState === 'corrige') {
            this.$emit('update:formItemOfflineStatus', 'potentially_created_or_modified');
        } else {
            this.$emit('update:formItemOfflineStatus', 'potentially_added');
        }
    }
}
</script>

<template>

    <div class="row rowSysma">
    <!-- FOR EACH POSSIBLE TYPE OF INPUT WE PREPARE THE INPUT WITH THE RIGHT PROPS / STRUCTURE -->
        <template v-if="itemInformations['type'] === 'textType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <inputForm :inputID="itemInformations['id']" :inputName="itemInformations['name']"
                    :inputValue="formItemValue"
                    @update:inputValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'textChoiceType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <selectForm :selectID="itemInformations['id']" :selectName="itemInformations['name']"
                    :options="itemInformations['options']"
                    @update:selectedOption="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'longTextType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <longTextInput :longInputID="itemInformations['id']" :longInputName="itemInformations['name']"
                    :longInputValue="formItemValue"
                    @update:longInputValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'booleanType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <selectForm :selectID="itemInformations['id']" :selectName="itemInformations['name']"
                    :options="itemInformations['options']"
                    @update:selectedOption="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'multipleTextChoiceType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <multipleTextChoice :options="itemInformations['options']"
                    @update:selectedValues="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'dateType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <inputDate :inputDateID="itemInformations['id']" :inputDateName="itemInformations['name']"
                    :isCreationDate="itemInformations['isCreationDate']"
                    @update:inputDateValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>

        <template v-else-if="itemInformations['type'] === 'integerType' || itemInformations['type'] === 'floatType'">
            <div class="col-md-4 col-xs-4 colonne1">
                <acronym :title="itemInformations['id']"> {{ itemInformations["label"] }} </acronym>
            </div>
            <div :id="itemInformations['id']" class="col-md-6 col-xs-6">
                <numberInput :inputID="itemInformations['id']"
                    :inputName="itemInformations['name']"
                    :inputType="itemInformations['type']"
                    :inputValue="formItemValue"
                    @update:inputNumberValue="newValue => {formItemValue=newValue; $emit('update:formItemValue', formItemValue);}" />
            </div>
        </template>
    <!-- --- --- --- --- --- -->


    <!-- BUTTON CORRIGER : MISE A JOUR (TODO : MAKE A BETTER REPRODUCTION OF THE "ORIGINAL" BUTTON) -->
        <div v-if="itemInformations.time_tracking === 1 || itemInformations.time_tracking === '1'" class="col-md-2 col-xs-2">
            <!-- <div class="toggle btn off btn-xs btn-default"
            data-toggle="toggle"
            style="width: 100px; height: 22px;">
                <input :name="'toggle' + itemInformations['id']"
                type="checkbox"
                class="toggle toggleVal"
                data-size="mini"
                data-width="100"
                data-toggle="toggle"
                data-off="<span class='glyphicon glyphicon-pencil'></span> Corriger"
                data-on="<span class='glyphicon glyphicon-share-alt'></span> M. à jour"
                data-onstyle="default"
                data-offstyle="default">
                <div class="toggle-group">
                    <label class="btn btn-default btn-xs toggle-on">
                        <span class="glyphicon glyphicon-share-alt"></span>
                        M. à jour
                    </label>
                    <label class="btn btn-default btn-xs active toggle-off">
                        <span class="glyphicon glyphicon-pencil"></span>
                        Corriger
                    </label>
                    <span class="toggle-handle btn btn-default btn-xs"></span>
                </div>
            </div> -->
            <!-- <button class="btn btn-default btn-xs"
            style="color: #333;background-color: #d4d4d4;border-color: #8c8c8c;"
            v-show="buttonState === 'corrige'"
            @click="toggleButton">
                <label class="btn btn-default btn-xs active">
                    <span class="glyphicon glyphicon-pencil"></span>
                    Corriger
                </label>
            </button>
            <button class="btn btn-default btn-xs"
            style="color: #333;background-color: #d4d4d4;border-color: #8c8c8c;"
            v-show="buttonState === 'maj'"
            @click="toggleButton">
                <label class="btn btn-default btn-xs active">
                    <span class="glyphicon glyphicon-share-alt"></span>
                    M. à jour
                </label>
            </button>
            <span class="glyphicon glyphicon-question-sign text-muted" title="M. à jour : l'ancienne donnée sera archivée. Corriger : l'ancienne donnée sera remplacée"></span>
        </div> -->
            <!-- <button class="btn btn-default btn-xs active"
            v-show="buttonState === 'corrige'"
            @click="toggleButton">
                <span class="btn btn-default btn-xs"></span>
                <span class="glyphicon glyphicon-pencil" style="padding-left: 12px;"></span>
                Corriger
            </button>
            <button class="btn btn-default btn-xs active"
            v-show="buttonState === 'maj'"
            @click="toggleButton">
                <span class="glyphicon glyphicon-share-alt" style="padding-left: 12px;"></span>
                M. à jour
            </button>
            <span class="glyphicon glyphicon-question-sign text-muted" title="M. à jour : l'ancienne donnée sera archivée. Corriger : l'ancienne donnée sera remplacée"></span> -->
            <div class="toggle btn btn-xs btn-default" style="width: 100px; height: 22px;">
                <div class="toggle-group">
                    <label v-show="buttonState === 'maj'" class="btn btn-default btn-xs" :id="itemInformations.id + 'AddValueBtn'" style="width: 100px;" @click="toggleButton">
                        <span class="glyphicon glyphicon-share-alt"></span>
                        M. à jour
                    </label>
                    <label v-show="buttonState === 'corrige'" class="btn btn-default btn-xs active" :id="itemInformations.id + 'ModifyValueBtn'" style="width: 100px;" @click="toggleButton">
                        <span class="glyphicon glyphicon-pencil"></span>
                        Corriger
                    </label>
                    <label class="btn btn-default btn-xs" id="blankBtn" style="width: 100px;">
                        <span class="glyphicon glyphicon-share-alt"></span>
                        a
                    </label>
                    <span class="toggle-handle btn btn-default btn-xs"></span>
                </div>
            </div>
        </div>
    <!-- --- --- --- --- --- -->
    </div>

</template>